// This is the Relay sketch to decode 2 more signals and drive external circuitry
// JDW 2009

// the pin that will tell the relay-controller to turn the relay ON or OFF.

int relay_Pin1 = 7;
int relay_Pin2 = 8;

int fan_Pin = 12;

// update pulseIn every x milliseconds. 500 means 2 times per second. I would not make this more than 1000 (1 second). You can actually run the update as fast as you want (ie. update = 1) with about 3 different pulseIn's at a time, but the resolution is a bit choppy (it misses quite a few signals so speed-control might be a bit choppy)
int update = 500;

int ledPin1 = 13;
int ledPin2 = 14;

// collect the R/C signal on ANY pin using pulseIn, I'm using pin 4 b/c it is just a digital pin. check the Arduino reference pages for usage.
int ppm1 = 4; 

// we want it to be unsigned, because it is only usable if it is positive, so we don't want any negative numbers.
unsigned int relay_val;

void setup() {
// start the serial monitor and setup the inputs and outputs.
  Serial.begin(9600);

  //motor1 pins
  pinMode(relay_Pin1, OUTPUT);
  pinMode(relay_Pin2, OUTPUT);
  
  pinMode(fan_Pin, OUTPUT);

  //led's
  pinMode(ledPin1, OUTPUT);
  pinMode(ledPin2, OUTPUT);

  //PPM inputs from RC receiver
  pinMode(ppm1, INPUT); //Pin 2 as input
	
//start off with the relay OFF and the optional fan pin ON always (as long as the main power switch is ON).
  digitalWrite(relay_Pin1, HIGH);
  digitalWrite(relay_Pin2, LOW);
  digitalWrite(fan_Pin, HIGH);
  
}

// create a function called "pulse()" that when called, will use pulseIn to determine the R/C pulse length
void pulse() {

// use pulseIn to check the value of the channel connected to the flip-switch (on/off) on the transmitter, set that value to "relay_val".
  relay_val = pulseIn(ppm1, HIGH, 20000);

}

void loop() {

// start the loop by calling the "pulse()" function above to get a value for "relay_val"
  pulse();

// if "relay_val" is NOT between 2000 and 2200, turn the relay OFF nad turn LED1 ON, ie. if the transmitter is ON, but I flip the channel1 flip-switch OFF, the pulse drops to 850, which will turn the Relay OFF. If the transmitter is turned off, the signal will be 0 which is not between 2000 and 2200, so OFF again. 
  if (relay_val < 2000 || relay_val > 2200) {
    
    digitalWrite(relay_Pin1, HIGH); 
    digitalWrite(relay_Pin2, LOW); 
    digitalWrite(ledPin2, LOW);
    digitalWrite(ledPin1, HIGH);
    
    delay(update);

  }

// if "relay_val" IS between 2000 and 2200, ie. 2126 microseconds like it is on my radio, turn the motor-controller Relay ON and let's ROLL, also turn on LED2.
  else {

   
    digitalWrite(relay_Pin2, HIGH); 
    digitalWrite(relay_Pin1, LOW);
    digitalWrite(ledPin1, LOW);
    digitalWrite(ledPin2, HIGH);
    
    delay(update);
    }
 

  //print relay_val to show me how many microseconds each R/C pulse is exactly, well down to 4 microsecond increments anyways (arduino limited)
  Serial.print(" Relay:  ");
  Serial.print(relay_val);
  Serial.println("  ");


  	
}
